<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/cores/WIB_TSE/altera_tse_xcvr_resync.v Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_51d9c9f08f6806a0f97badf342e5b4d7.html">cores</a></li><li class="navelem"><a class="el" href="dir_504cc38e9ca3abe9147e6ee316c35742.html">WIB_TSE</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">altera_tse_xcvr_resync.v</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; <span class="keyword">// (C) 2001-2016 Altera Corporation. All rights reserved.</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="keyword">// Your use of Altera Corporation&#39;s design tools, logic functions and other </span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">// software and tools, and its AMPP partner logic functions, and any output </span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">// files any of the foregoing (including device programming or simulation </span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">// files), and any associated documentation or information are expressly subject </span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">// to the terms and conditions of the Altera Program License Subscription </span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">// Agreement, Altera MegaCore Function License Agreement, or other applicable </span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">// license agreement, including, without limitation, that your use is for the </span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">// sole purpose of programming logic devices manufactured by Altera and sold by </span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">// Altera or its authorized distributors.  Please refer to the applicable </span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">// agreement for further details.</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">// Module: altera_tse_xcvr_resync</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="keyword">// Description:</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">//  A general purpose resynchronization module.</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">//  </span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">//  Parameters:</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">//    SYNC_CHAIN_LENGTH</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">//      - Specifies the length of the synchronizer chain for metastability</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">//        retiming.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">//    WIDTH</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">//      - Specifies the number of bits you want to synchronize. Controls the width of the</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">//        d and q ports.</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">//    SLOW_CLOCK - USE WITH CAUTION. </span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">//      - Leaving this setting at its default will create a standard resynch circuit that</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">//        merely passes the input data through a chain of flip-flops. This setting assumes</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">//        that the input data has a pulse width longer than one clock cycle sufficient to</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">//        satisfy setup and hold requirements on at least one clock edge.</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">//      - By setting this to 1 (USE CAUTION) you are creating an asynchronous</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">//        circuit that will capture the input data regardless of the pulse width and </span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">//        its relationship to the clock. However it is more difficult to apply static</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">//        timing constraints as it ties the data input to the clock input of the flop.</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">//        This implementation assumes the data rate is slow enough</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">//</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">`timescale</span> 1ns/1ns</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="code" href="enumaltera__tse__xcvr__resync.html">   39</a></span>&#160;<span class="vhdlkeyword">module</span> <a class="code" href="enumaltera__tse__xcvr__resync.html">altera_tse_xcvr_resync</a> #(</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="vhdlkeyword">parameter</span> <span class="vhdlchar">SYNC_CHAIN_LENGTH</span> = <span class="vhdllogic">2</span>,  <span class="keyword">// Number of flip-flops for retiming</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="vhdlkeyword">parameter</span> <span class="vhdlchar">WIDTH</span>             = <span class="vhdllogic">1</span>,  <span class="keyword">// Number of bits to resync</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="vhdlkeyword">parameter</span> <span class="vhdlchar">SLOW_CLOCK</span>        = <span class="vhdllogic">0</span>   <span class="keyword">// See description above</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  ) (</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="vhdlkeyword">input</span>   <span class="vhdlkeyword">wire</span>              <span class="vhdlchar">clk</span>,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="vhdlkeyword">input</span>   <span class="vhdlkeyword">wire</span>  [<span class="vhdlchar">WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>] <span class="vhdlchar">d</span>,</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <span class="vhdlkeyword">output</span>  <span class="vhdlkeyword">wire</span>  [<span class="vhdlchar">WIDTH</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>] <span class="vhdlchar">q</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  );</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="vhdlkeyword">localparam</span>  <span class="vhdlchar">INT_LEN</span>   = (<span class="vhdlchar">SYNC_CHAIN_LENGTH</span> &gt; <span class="vhdllogic">0</span>) ? <span class="vhdlchar">SYNC_CHAIN_LENGTH</span> : <span class="vhdllogic">1</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="vhdlkeyword">genvar</span> <span class="vhdlchar">ig</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="keyword">// Generate a synchronizer chain for each bit</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="vhdlkeyword">generate</span> <span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  <span class="vhdlkeyword">for</span>(<span class="vhdlchar">ig</span>=<span class="vhdllogic">0</span>;<span class="vhdlchar">ig</span>&lt;<span class="vhdlchar">WIDTH</span>;<span class="vhdlchar">ig</span>=<span class="vhdlchar">ig</span>+<span class="vhdllogic">1</span>) <span class="vhdlkeyword">begin</span> : <span class="vhdlchar">resync_chains</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="vhdlkeyword">wire</span>                <span class="vhdlchar">d_in</span>;   <span class="keyword">// Input to sychronization chain.</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="vhdlkeyword">reg</span>   [<span class="vhdlchar">INT_LEN</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>] <span class="vhdlchar">r</span> = {<span class="vhdlchar">INT_LEN</span>{<span class="vhdllogic">1&#39;b0</span>}};</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="vhdlkeyword">wire</span>  [<span class="vhdlchar">INT_LEN</span>  :<span class="vhdllogic">0</span>] <span class="vhdlchar">next_r</span>; <span class="keyword">// One larger real chain</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">q</span>[<span class="vhdlchar">ig</span>]   = <span class="vhdlchar">r</span>[<span class="vhdlchar">INT_LEN</span>-<span class="vhdllogic">1</span>]; <span class="keyword">// Output signal</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">next_r</span>  = {<span class="vhdlchar">r</span>,<span class="vhdlchar">d_in</span>};</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="vhdlkeyword">always</span> @(<span class="vhdlkeyword">posedge</span> <span class="vhdlchar">clk</span>)</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;      <span class="vhdlchar">r</span> &lt;= <span class="vhdlchar">next_r</span>[<span class="vhdlchar">INT_LEN</span>-<span class="vhdllogic">1</span>:<span class="vhdllogic">0</span>];</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">// Generate asynchronous capture circuit if specified.</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="vhdlkeyword">if</span>(<span class="vhdlchar">SLOW_CLOCK</span> == <span class="vhdllogic">0</span>) <span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;      <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">d_in</span> = <span class="vhdlchar">d</span>[<span class="vhdlchar">ig</span>];</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;      <span class="vhdlkeyword">wire</span>  <span class="vhdlchar">d_clk</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;      <span class="vhdlkeyword">reg</span>   <span class="vhdlchar">d_r</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;      <span class="vhdlkeyword">wire</span>  <span class="vhdlchar">clr_n</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;      <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">d_clk</span> = <span class="vhdlchar">d</span>[<span class="vhdlchar">ig</span>];</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;      <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">d_in</span>  = <span class="vhdlchar">d_r</span>;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;      <span class="vhdlkeyword">assign</span>  <span class="vhdlchar">clr_n</span> = ~<span class="vhdlchar">q</span>[<span class="vhdlchar">ig</span>] | <span class="vhdlchar">d_clk</span>; <span class="keyword">// Clear when output is logic 1 and input is logic 0</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;      <span class="keyword">// Asynchronously latch the input signal.</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;      <span class="vhdlkeyword">always</span> @(<span class="vhdlkeyword">posedge</span> <span class="vhdlchar">d_clk</span> <span class="vhdlkeyword">or</span> <span class="vhdlkeyword">negedge</span> <span class="vhdlchar">clr_n</span>)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="vhdlkeyword">if</span>(!<span class="vhdlchar">clr_n</span>)      <span class="vhdlchar">d_r</span> &lt;= <span class="vhdllogic">1&#39;b0</span>;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="vhdlkeyword">else</span> <span class="vhdlkeyword">if</span>(<span class="vhdlchar">d_clk</span>)  <span class="vhdlchar">d_r</span> &lt;= <span class="vhdllogic">1&#39;b1</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="vhdlkeyword">end</span> <span class="keyword">// SLOW_CLOCK</span></div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;  <span class="vhdlkeyword">end</span> <span class="keyword">// for loop</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="vhdlkeyword">end</span> <span class="keyword">// generate</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="vhdlkeyword">endgenerate</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="vhdlkeyword">endmodule</span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:25 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
